# $Id: ITO.spec,v 2.26 2012/11/09 20:56:17 ksb Exp $
# $KeyFile: ${echo:-echo} rcsvg.m

%define _local_prefix		/usr/local
%define _local_bindir		%{_local_prefix}/bin
%define _local_mandir		%{_local_prefix}/man/man1

# for signing of packages
#%_signature gpg
#%_gpg_name FIXME@example.org

# %dist should be defined on the target but in case it isn't we can guess one
%define distguess %(cat /etc/{redhat,fedora,suse,ubuntu}-release | sed -e 's/Fedora Core/fc@/; s/Fedora/f@/; s/Red Hat[^0-9]*\(Enterprise|Server\)*[^0-9]*/rhel@/; s/Red Hat[^0-9]*/rh/; s/.*Suse[^0-9]*/se@/; s/Ubuntu[^0-9]*/ubuntu@/; s/@[^0-9]*//;s/\([0-9][0-9]*\)[^0-9][^0-9]*\([0-9][0-9]*\)/\1_\2/; s/[^0-9]*$//')
%{!?dist:%define dist .%{distguess}}

# Do not generate debugging packages by default - older versions of rpmbuild
# (like RehHat 6.2) choke on the line with the percent in the macro name:
# We need a sed spell on RH6.x to "s/\(^.define \)%d/\1d/", Sigh. -- ksb
%define debug_package %{nil}

Name:		rcsvg
Version:	2.17
Release:	4%{?dist}
BuildRoot:	/tmp/%{name}-%{version}-%{release}
Vendor:		NPCGuild.org
Summary:	NPC tool for extraction up-to-date RCS versions
Group:		Utilities
License:	BSD
URL:		http://patch.sac.fedex.com/RPMS
Source:		http://patch.sac.fedex.com/tarball/%{name}-%{version}.tgz
BuildRequires:	gcc install_base
# Autoreq:0 prevents misleading depencies from being generated. Normally, this
# is perfectly sane; however, the system is picking up mk directives and
# mkcmd directives as well as system depencies.
Autoreq:	0
Requires:	rcs install_base

%description
This is needed only to run a copy of the master source buuld environment.
The level2s program depends on it to extract stable source files from RCS.

%prep
%setup -q
%build
%install
mkdir -p %{buildroot}/usr/local/man/man1 %{buildroot}/usr/local/bin
F=`mktemp -d /tmp/bmHMXXXXXX`
mmsrc -y INTO=$F -Cauto.cf -- make DESTDIR=%{buildroot} install
mk -mInstall -D DESTDIR=%{buildroot} *.man
rm -rf $F
find %{buildroot} -depth -type d -name OLD -exec rm -rf {\} \;

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root)
%{_local_bindir}/%{name}
%doc %{_local_mandir}/

%changelog
* Fri Nov  9 2012 KS Braunsdorf
- added more to HTML docs
* Mon Sep 10 2012 KS Braunsdorf
- updated manual page, html page, Makefiles
- ported to DARWIN (MacOS 10)
* Tue Nov 18 2008 KS Braunsdorf
- upgrade to better build packaging
* Sat Nov 08 2008 KS Braunsdorf
- Built the RPM spec file and added it to the msrc cache
